package com.openhis.financial.service;

import java.util.List;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.openhis.financial.domain.Contract;

/**
 * 合同管理Service接口
 *
 * @author system
 * @date 2025-02-20
 */
public interface IContractService extends IService<Contract> {

    /**
     * 根据医保码找合同信息
     *
     * @param contractNo 医保码
     * @return 合同实体
     */
    Contract getByContractNo(String contractNo);

    /**
     * 查询租户合同信息分页
     *
     * @param tenantId 租户ID
     * @param pageNum 当前页
     * @param pageSize 每页多少条
     * @return 租户合同信息分页
     */
    IPage<Contract> getTenantContractPage(Integer tenantId, Integer pageNum, Integer pageSize);

    /**
     * 查询租户合同信息详情
     *
     * @param id ID
     * @return 租户合同信息详情
     */
    Contract getTenantContractDetail(Long id);

    /**
     * 新增租户合同信息
     *
     * @param contract 合同管理实体
     */
    void addTenantContract(Contract contract);

    /**
     * 编辑租户合同信息
     *
     * @param contract 合同管理实体
     */
    void editTenantContract(Contract contract);

    /**
     * 删除租户合同信息
     *
     * @param id ID
     */
    void delTenantContract(Long id);

    /**
     * 查詢合同的集合
     * 
     * @return
     */
    List<Contract> getContractList();

    /**
     * 查詢合同的集合
     * 
     * @return
     */
    List<Contract> getRedisContractList();

    /**
     * 通過合同編碼查詢合同
     * 
     * @return
     */
    Contract getContract(String contractNo);

    /**
     * 根据参保地信息找到对应的合同
     * 
     * @param insuplcAdmdvs
     * @return
     */
    Contract getContractByInsuplcAdmdvs(String insuplcAdmdvs);

    /**
     * 查詢合同的集合
     * 
     * @return 合同集合
     */
    List<Contract> getContractListByYb();

}